// Last Change for CiK2.0 
// 12 Mar 93 
`resetall
`timescale 1 ns / 10 ps
`celldefine
`suppress_faults
module l3s_y(t,l0,l1,l2,i0,i1);
	output t;
	input l0,l1,l2,i0,i1;
	wire vdd = 1;
	reg notifier,recover;


	// specify block
	specify
		// specify parameters
		specparam          tl0_tf	= 0.0 ;
		specparam          tl1_tf	= 0.0 ;
		specparam          tl2_tf	= 0.0 ;
		specparam          tl0_tr	= 0.0 ;
		specparam          tl1_tr	= 0.0 ;
		specparam          tl2_tr	= 0.0 ;
		specparam           ti0_tf	= 0.0 ;
		specparam           ti1_tf	= 0.0 ;
		specparam           ti0_tr	= 0.0 ;
		specparam           ti1_tr	= 0.0 ;
		specparam            l0wh	= 0.0 ;
		specparam            l1wh	= 0.0 ;
		specparam            l2wh	= 0.0 ;
		specparam           i0hold	= 0.0 ;
		specparam           i1hold	= 0.0 ;
		specparam          i0setup	= 0.0 ;
		specparam          i1setup	= 0.0 ;
		specparam        Fdrive$t	= 0.0 ;
		specparam        eresof$t	= 2048;
		specparam        Rdrive$t	= 0.0 ;
		specparam        eresor$t	= 1848;
		specparam       Maxload$t	= 0.0 ;
		specparam          dcap$t	= 0.0 ;
		specparam         Load$l0	= 0.025 ;
		specparam         Load$l1	= 0.026 ;
		specparam         Load$l2	= 0.026 ;
		specparam       inload$l0	= 0.025 ;
		specparam       inload$l1	= 0.026 ;
		specparam       inload$l2	= 0.026 ;
		specparam          Load$i0	= 0.110 ;
		specparam          Load$i1	= 0.110 ;
		specparam        inload$i0	= 0.110 ;
		specparam        inload$i1	= 0.110 ;
		specparam          Trans$	= 0.0 ;
		specparam           Area$	= 2016;
		specparam          Power$	= 0.0 ;

		// path delays
		(posedge l0 =>   (t +: i0))	= (tl0_tr,tl0_tf);
                if (l0)
		(         i0 +=>          t)	= (ti0_tr,ti0_tf);

		// timing check
		$setuphold(negedge l0, i0, i0setup, i0hold, notifier);
		$width(posedge l0, l0wh, 0, notifier);
		$width(negedge l0, l0wh, 0, notifier);
		// path delays
		(posedge l1 =>   (t +: i1))	= (tl1_tr,tl1_tf);
                if (l1)
		(         i1 +=>          t)	= (ti1_tr,ti1_tf);

		// timing check
		$setuphold(negedge l1, i1, i1setup, i1hold, notifier);
		$width(posedge l1, l1wh, 0, notifier);
		$width(negedge l1, l1wh, 0, notifier);
	endspecify

	// instantiation
	wire x1;
	wire x2;
	wire i_mux;
	wire l_or;
	wire reset;
	and(x1,i0,l0);
	and(x2,i1,l1);
	or(i_mux,x1,x2);
	or(l_or,l0,l1);
	not (set,l2);
	`ifdef SYNTH
		reg ti;
		always @(i_mux or l_or)
			if( l_or==1 ) ti=i_mux;
	`else
		udp_lat (ti,l_or,i_mux,vdd,set,notifier,recover);
	`endif

	buf (t,ti);

endmodule
`nosuppress_faults
`endcelldefine
