# include <genlib.h>
main ()
{
DEF_LOFIG ("muxe");
/* declaration of the cell's external connectors */
LOCON ("RA[3:0]",'I',"ra[3:0]");
LOCON ("RB[3:0]",'I',"rb[3:0]");
LOCON ("Q[3:0]",'I',"q[3:0]");
LOCON ("D[3:0]",'I',"d[3:0]");
LOCON ("R[3:0]",'O',"r[3:0]");
LOCON ("S[3:0]",'O',"s[3:0]");
LOCON ("I[2:0]",'I',"i[2:0]");
LOCON ("VDD",'I',"vdd");
LOCON ("VSS",'I',"vss");

/* generation of the multiplexing commands */

LOINS ("n1_y","n11me","i[2]","ni2","vdd","vss",0);
LOINS ("n1_y","n12me","i[1]","ni1","vdd","vss",0);
LOINS ("n1_y","n13me","i[0]","ni0","vdd","vss",0);
/* ra ->  ALU's S-input */
LOINS ("a2_y","a21me","ni1","i[2]","selas","vdd","vss",0);
/* rb ->  ALU's S-input */
LOINS ("a2_y","a22me","ni2","i[0]","selbs","vdd","vss",0);
LOINS ("o2_y","o21me","i[1]","ni2","o21s","vdd","vss",0);
/* ra ->  ALU's R-input */
LOINS ("a2_y","a23me","ni2","ni1","selar","vdd","vss",0);
LOINS ("o2_y","o22me","i[1]","i[0]","o22s","vdd","vss",0);
/* q ->  ALU's R-input */
LOINS ("a2_y","a24me","o21s","ni0","selqs","vdd","vss",0);
/* d ->  ALU's R-input */
LOINS ("a2_y","a25me","o22s","i[2]","seldr","vdd","vss",0);

/* taking in account of the above commands */

/* rb(3 downto 0) -> s(3 downto 0) */
LOINS ("a2_y","a26ms","rb[0]","selbs","srb0","vdd","vss",0);
LOINS ("a2_y","a27ms","rb[1]","selbs","srb1","vdd","vss",0);
LOINS ("a2_y","a28ms","rb[2]","selbs","srb2","vdd","vss",0);
LOINS ("a2_y","a29ms","rb[3]","selbs","srb3","vdd","vss",0);

/* ra(3 downto 0) -> s(3 downto 0) */
LOINS ("a2_y","a210ms","ra[0]","selas","sra0","vdd","vss",0);
LOINS ("a2_y","a211ms","ra[1]","selas","sra1","vdd","vss",0);
LOINS ("a2_y","a212ms","ra[2]","selas","sra2","vdd","vss",0);
LOINS ("a2_y","a213ms","ra[3]","selas","sra3","vdd","vss",0);

/* ra(3 downto 0) -> r(3 downto 0) */
LOINS ("a2_y","a214ms","ra[0]","selar","ssa0","vdd","vss",0);
LOINS ("a2_y","a215ms","ra[1]","selar","ssa1","vdd","vss",0);
LOINS ("a2_y","a216ms","ra[2]","selar","ssa2","vdd","vss",0);
LOINS ("a2_y","a217ms","ra[3]","selar","ssa3","vdd","vss",0);

/* q(3 downto 0) -> r(3 downto 0) */
LOINS ("a2_y","a218ms","q[0]","selqs","srq0","vdd","vss",0);
LOINS ("a2_y","a219ms","q[1]","selqs","srq1","vdd","vss",0);
LOINS ("a2_y","a220ms","q[2]","selqs","srq2","vdd","vss",0);
LOINS ("a2_y","a221ms","q[3]","selqs","srq3","vdd","vss",0);

/* d(3 downto 0) -> r(3 downto 0) */
LOINS ("a2_y","a222ms","d[0]","seldr","ssd0","vdd","vss",0);
LOINS ("a2_y","a223ms","d[1]","seldr","ssd1","vdd","vss",0);
LOINS ("a2_y","a224ms","d[2]","seldr","ssd2","vdd","vss",0);
LOINS ("a2_y","a225ms","d[3]","seldr","ssd3","vdd","vss",0);

/* last stage of the multiplexer : r and s ALU-inputs */

LOINS ("o3_y","o31ms","srb0","sra0","srq0","s[0]","vdd","vss",0);
LOINS ("o3_y","o32ms","srb1","sra1","srq1","s[1]","vdd","vss",0);
LOINS ("o3_y","o33ms","srb2","sra2","srq2","s[2]","vdd","vss",0);
LOINS ("o3_y","o34ms","srb3","sra3","srq3","s[3]","vdd","vss",0);

LOINS ("o2_y","o23ms","ssa0","ssd0","r[0]","vdd","vss",0);
LOINS ("o2_y","o24ms","ssa1","ssd1","r[1]","vdd","vss",0);
LOINS ("o2_y","o25ms","ssa2","ssd2","r[2]","vdd","vss",0);
LOINS ("o2_y","o26ms","ssa3","ssd3","r[3]","vdd","vss",0);

SAVE_LOFIG();
}
