;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Opus Pre-defined Class, Device and Wire Section
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


tcCreateCDSDeviceClass()
;
tfcDefineDeviceClassProp(
; (viewName        devClassName      propName          propValue)
   (symbolic        syEnhancement     function          "transistor")
   (symbolic        syDepletion       function          "transistor")
   (symbolic        syContact         function          "contact")
   (symbolic        syPin             function          "pin")
;  (symbolic        syRectPin         function          "pin")
)

;
; no syEnhancement devices
;

;
; no syDepletion devices
;

tfcDefineSymContactDevice(
; (name viaLayer viaPurpose layer1 purpose1 layer2 purpose2
;  w l (row column xPitch yPitch xBias yBias) encByLayer1 encByLayer2 legalRegion)

;  (CONT_POLY L_CONT drawing L_ALU1 drawing L_POLY drawing
;  1 1 (1 1 1.5 1.5 center center) 0.5 1 _NA_)

;  (CONT_DIF_N L_CONT drawing L_ALU1 drawing L_NDIF drawing
;  1 1 (1 1 1.5 1.5 center center) 0.5 1 _NA_)

;  (CONT_DIF_P L_CONT drawing L_ALU1 drawing L_PDIF drawing
;  1 1 (1 1 1.5 1.5 center center) 0.5 1 _NA_)

;  (CONT_BODY_N L_CONT drawing L_ALU1 drawing L_NTIE drawing
;  1 1 (1 1 1.5 1.5 center center) 0.5 1 _NA_)

;  (CONT_BODY_P L_CONT drawing L_ALU1 drawing L_PTIE drawing
;  1 1 (1 1 1.5 1.5 center center) 0.5 1 _NA_)

  (CONT_VIA L_VIA1 drawing L_ALU1 drawing L_ALU2 drawing
  1 1 (1 1 1.5 1.5 center center) 0.5 1 _NA_)

;  (CONT_VIA2 L_VIA2 drawing L_ALU3 drawing L_ALU2 drawing
;  1 1 (1 1 1.5 1.5 center center) 1 2 _NA_)

;  (C_X_N L_GATE drawing L_NDIF drawing L_NDIF drawing
;  1 1 (1 1 1.5 1.5 center center) 2 2 _NA_)

;  (C_X_P L_GATE drawing L_PDIF drawing L_PDIF drawing
;  1 1 (1 1 1.5 1.5 center center) 2 2 _NA_)
)

;
; no syPin devices
;

;tfcDefineSymRectPinDevice(
; (name maskable layer1 purpose1 w l legalRegion)
;  (CONN_POLY t L_POLY drawing 1 1 _NA_)
;  (CONN_TPOLY t L_TPOLY drawing 1 1 _NA_)
;  (CONN_ALU1 t L_ALU1 drawing 1 1 _NA_)
;  (CONN_ALU2 t L_ALU2 drawing 2 2 _NA_)
;  (CONN_ALU3 t L_ALU3 drawing 4 2 _NA_)
;  (CONN_NWELL t L_NWELL drawing 2 2 _NA_)
;  (CONN_PWELL t L_PWELL drawing 2 2 _NA_)
;  (CONN_NDIF t L_NDIF drawing 2 1 _NA_)
;  (CONN_PDIF t L_PDIF drawing 2 1 _NA_)
;  (CONN_NTIE t L_NTIE drawing 2 1 _NA_)
;  (CONN_PTIE t L_PTIE drawing 2 1 _NA_)
;  (CONN_TALU1 t L_TALU1 drawing 1 1 _NA_)
;  (CONN_TALU2 t L_TALU2 drawing 2 2 _NA_)
;  (CONN_TALU3 t L_TALU3 drawing 4 2 _NA_)
;)

tfcDefineSymPinDevice(
;(name   maskable layer1 purpose1 w1 layer2 purpose2 w2 legalRegion)
;  (CONN_POLY t L_POLY drawing 1 _NA_ _NA_ _NA_ _NA_)
;  (CONN_TPOLY t L_TPOLY drawing 1 _NA_ _NA_ _NA_ _NA_)
;  (CONN_ALU1 t L_ALU1 drawing 1 _NA_ _NA_ _NA_ _NA_)
;  (CONN_ALU3 t L_ALU3 drawing 4 _NA_ _NA_ _NA_ _NA_)
;  (CONN_NWELL t L_NWELL drawing 2 _NA_ _NA_ _NA_ _NA_)
;  (CONN_PWELL t L_PWELL drawing 2 _NA_ _NA_ _NA_ _NA_)
;  (CONN_NDIF t L_NDIF drawing 2 _NA_ _NA_ _NA_ _NA_)
;  (CONN_PDIF t L_PDIF drawing 2 _NA_ _NA_ _NA_ _NA_)
;  (CONN_NTIE t L_NTIE drawing 2 _NA_ _NA_ _NA_ _NA_)
;  (CONN_PTIE t L_PTIE drawing 2 _NA_ _NA_ _NA_ _NA_)
;  (CONN_TALU1 t L_TALU1 drawing 1 _NA_ _NA_ _NA_ _NA_)
;  (CONN_TALU2 t L_TALU2 drawing 2 _NA_ _NA_ _NA_ _NA_)
;  (CONN_TALU3 t L_TALU3 drawing 4 _NA_ _NA_ _NA_ _NA_)
  (CONN_ALU2 t L_ALU2 drawing 2 _NA_ _NA_ _NA_ _NA_)
)

tfcDefineSymWire(
; (name layer purpose defaultWidth minWidth maxWidth legalRegion)
  (ALU3 L_ALU3 drawing 4 2 _NA_ _NA_)
  (NWELL L_NWELL drawing 4 2 _NA_ _NA_)
  (PDIF L_PDIF drawing 2 2 _NA_ _NA_)
  (NTIE L_NTIE drawing 2 2 _NA_ _NA_)
  (PWELL L_PWELL drawing 4 2 _NA_ _NA_)
  (NDIF L_NDIF drawing 2 2 _NA_ _NA_)
  (POLY L_POLY drawing 1 1 _NA_ _NA_)
  (TPOLY L_TPOLY drawing 1 1 _NA_ _NA_)
  (ALU1 L_ALU1 drawing 1 1 _NA_ _NA_)
  (ALU2 L_ALU2 drawing 2 2 _NA_ _NA_)
  (PTIE L_PTIE drawing 2 2 _NA_ _NA_)
  (TALU1 L_TALU1 drawing 1 1 _NA_ _NA_)
  (TALU2 L_TALU2 drawing 2 2 _NA_ _NA_)
  (TALU3 L_TALU3 drawing 4 2 _NA_ _NA_)
)


tfcDefineSymWireProp(
; (wireName        propName          propValue)
  (ALU3            extension         1)
  (NWELL           extension         0)
  (PDIF            extension         0.500000)
  (NTIE            extension         0.500000)
  (PWELL           extension         0)
  (NDIF            extension         0.500000)
  (POLY            extension         0.500000)
  (TPOLY           extension         0.500000)
  (ALU1            extension         0.500000)
  (ALU2            extension         1)
  (PTIE            extension         0.500000)
  (TALU1           extension         0.500000)
  (TALU2           extension         1)
  (TALU3           extension         1)
)

