/******************************************************************************/
/*                                                                            */
/*    	     FICHIER D'EXTRACTION DE LAYOUT                                   */
/*                                                                            */
/******************************************************************************/

drcExtractRules(

	L_NWELL = geomOr( "L_NWELL" )
  	L_PWELL = geomOr( "L_PWELL" ) 
	L_NDIF  = geomOr( "L_NDIF" )
	L_PDIF  = geomOr( "L_PDIF" )
  	L_NTIE  = geomOr( "L_NTIE" )
  	L_PTIE  = geomOr( "L_PTIE" )
  	L_POLY  = geomOr( "L_POLY" )
  	L_GATE  = geomOr( "L_GATE" )
	L_TPOLY = geomOr( "L_TPOLY" )
  	L_ALU1  = geomOr( "L_ALU1" )
  	L_TALU1 = geomOr( "L_TALU1" )
  	L_VIA1  = geomOr( "L_VIA1" )
  	L_ALU2  = geomOr( "L_ALU2" )
  	L_TALU2 = geomOr( "L_TALU2" )
  	L_VIA2  = geomOr( "L_VIA2" )
  	L_ALU3  = geomOr( "L_ALU3" )
  	L_TALU3 = geomOr( "L_TALU3" )
	L_CONT  = geomOr( "L_CONT" )
	L_REF_C  = geomOr( "L_REF_C" )

	ivIf( switch("extract?") then

	pwell = geomNot( L_NWELL )
        pgate = geomAnd( L_GATE L_PDIF )
        ngate = geomAnd( L_GATE L_NDIF )
	
	cont_gate = geomAnd( L_GATE L_POLY )
	cont_nwell = geomAnd( L_NTIE L_NWELL)
	cont_pwell = geomAnd( L_PTIE pwell)

        psd = geomAndNot( L_PDIF L_GATE )
        nsd = geomAndNot( L_NDIF L_GATE )
        
	ncont = geomAnd( L_NDIF L_NTIE )
	pcont = geomAnd( L_PDIF L_PTIE )

	geomConnect(
	via( cont_gate L_GATE L_POLY )

	via( cont_nwell L_NTIE L_NWELL )
	via( cont_pwell L_PTIE pwell )

	via( L_CONT psd  L_ALU1 )
	via( L_CONT nsd  L_ALU1 )
	via( L_CONT L_NTIE  L_ALU1 L_PTIE L_POLY )
;	via( L_CONT L_PTIE  L_ALU1 )
;	via( L_CONT L_POLY  L_ALU1 )

	via( L_VIA1 L_ALU1 L_ALU2 )

	via( ncont L_NDIF L_NTIE )
	via( pcont L_PDIF L_PTIE )
	)


	extractMOS( ngate (L_GATE "G") (nsd "D" "S") ( pwell  "B") "NTRANS symbol" )
	extractMOS( pgate (L_GATE "G") (psd "D" "S") ( L_NWELL "B") "PTRANS symbol" )

	saveRecognition( ngate "device")
	saveRecognition( pgate "device")
	
	ivIf( switch("lpe") then
		cap  = measureParasitic(area (L_NDIF not_over L_GATE) two_net 1.000000e-10)
		cap2 = measureParasitic(area (L_PDIF not_over L_GATE) two_net 1.000000e-10)
		saveParasitic(cap  "PLUS" "MINUS" "c" "pcapacitor symbol")
		saveParasitic(cap2 "PLUS" "MINUS" "c" "pcapacitor symbol")
	)

	
;	saveInterconnect( ( cont_gate  "L_ALU1") )
;	saveInterconnect( ( cont_nbulk "L_ALU2") )
;	saveInterconnect( ( cont_pwell "L_ALU3") )
;	saveInterconnect( ( nsd "L_NDIF") )
;	saveInterconnect( ( psd "L_PDIF") )
;	saveInterconnect( ( pwell "L_PWELL") )
;	saveInterconnect( L_NDIF L_PDIF L_GATE )
;	saveInterconnect( L_REF_C L_NDIF L_PDIF L_GATE L_POLY L_CONT L_ALU1 L_VIA1 L_ALU2 )
	copyGraphics( ("text" "drawing" ))
	)
)
