#include <stdio.h>
#include "mybanner.h"
#define WINDOW_SIZE 81
#define LINES 15
#define ASCENT 13
static char screen[LINES][WINDOW_SIZE];

void myfree(ptr)
void *ptr;
{
#ifdef lint
        (void)free((char *)ptr);
#else
        (void)free(ptr); /* lint makes a mistake here : expects (char *) */
#endif
}

void *myalloc(nbytes)
unsigned int nbytes;
{
	void    *pt;
	long myalloc_stat = 0; /* statistics on maximun allocated memory */

        myalloc_stat += nbytes;
        if (!(pt =(void *) malloc(nbytes))) 
	{
                (void)fflush(stdout);
                (void)fprintf(stderr,"*** memory error ***\n");
                (void)fprintf(stderr,"fatal myalloc error : not enough memory\n");
                exit(1);
        }
        return pt;
}

char *mystrdup(s)
char *s;
{
	char *t;
	t = (char *)myalloc((unsigned int)(strlen(s) + 1));
        strcpy(t, s);
        return(t);
}

static int indx(c)
char c;
{
	return c >= '0' && c <= '9' ? (int)c - '0'
										: isupper(c) ? (int)10 + c - 'A'
										: islower(c) ? (int)11 + 'Z' - 'A' + c - 'a'
										: -1;
}

static void banner(s, police, nl)
char *s;
char *police[][62];
int nl;
{
	int i, j, k, l, m;
	char *line;

	for (j = 0; j < nl; j++)
		for (i = 0; i < WINDOW_SIZE; i++)
			screen[j][i] = '\0';
	while (*s) {
		for (i = 0; i < nl; i++) {
			if ((j = indx(*s)) == -1) {
				fprintf(stderr,
					"mybanner: Error: Character out of [0-9A-Za-z] range\n");
				exit(1);
			}
			line = police[j][i];
			if (strlen(line) + strlen(screen[i]) >= WINDOW_SIZE) {
				fprintf(stderr,
	"mybanner: Error: Resulting size bigger than %d columns not allowed\n",
										WINDOW_SIZE - 1);
				exit(1);
			}
			strcat(screen[i], line);
			if (*(s + 1) != '\0')
				strcat(screen[i], " ");
		}
		s++;
	}
	for (m = l = -1, j = 0; j < nl; j++)
		for (i = 0; i < WINDOW_SIZE; i++)
			if (screen[j][i] == '@') {
				if (m == -1)
					m = j;
				l = j;
				break;
			}


	k = strlen(screen[0]);

	putc('\n', stdout);
	for (j = m; j <= l; j++) {
		for (i = 0; i < (WINDOW_SIZE - k) / 2; i++)
			putc(' ', stdout);
		for (i = 0; i < k; i++)
			putc(screen[j][i], stdout);
		putc('\n', stdout);
	}
}

static void cartouche(tool, tv, comment, date, av)
char *tool, *tv, *comment, *date, *av;
{
int i, j, k, l;
static char *msg[4] = {
	"%s",
	"Cadence-Alliance, CADAL %s,\"%s %s",
	"Copyright (c) %s,\"MASI, CAO-VLSI Team",
	"E-mail support:\"cadal@masi.ibp.fr"
};
int msgl[4];
char *str;

	/* rince off :
	   the buffer is filled with nul characteres. */
	for (j = 0; j < 8; j++)
		for (i = 0; i < WINDOW_SIZE; i++)
			screen[j][i] = '\0';
	i = strlen(tool);
	str = mystrdup(tool);
	for (k = 0; k < i; k++)
		str[k] = isupper(tool[k]) ? tolower(tool[k]) : tool[k];
	sprintf(screen[0], msg[0], comment);
	sprintf(screen[1], msg[1], av, str, tv);
	myfree(str);
	sprintf(screen[2], msg[2], date);
	strcat(screen[3], msg[3]);
	for (i = 1; i < 4; i++) {
		msgl[i] = strlen(screen[i]);
		j = j < msgl[i] ? msgl[i] : j;
	}
	for (i = 1; i < 4; i++)
		for (l = 0, k = 0; k < WINDOW_SIZE; k++) {
			if (screen[i][k] == '\0') {
				screen[i + 4][k + l] = '\0';
				break;
			}
			if (screen[i][k] == '"') { /* only once per line */
				for (; l <= j - msgl[i]; l++)
					screen[i + 4][k + l] = ' ';
				continue;
			}
			screen[i + 4][k + l] = screen[i][k];
		}
	/* cartouche :
	   output on stdout. */
	i = strlen(comment);
	putc('\n', stdout);
	for (k = 0; k < (WINDOW_SIZE - i) / 2; k++)
		putc(' ', stdout);
	puts(screen[0]);
	putc('\n', stdout);
	for (i = 1; i < 4; i++) {
		for (k = 0; k < (WINDOW_SIZE - j) / 2; k++)
			putc(' ', stdout);
		for (k = 0; k <= j; k++)
			if (screen[i + 4][k] != 0) /* not so nice, but */
				putc(screen[i + 4][k], stdout);
		putc('\n', stdout);
	}
	putc('\n', stdout);
}

void mybanner(tool, tv, comment, date, av)
char *tool, *tv, *comment, *date, *av;
{
	banner(tool, Unknown_Bold_Normal_14, 15);
	cartouche(tool, tv, comment, date, av);
}
