// Last Change for CiK2.0 
// 12 Mar 93 
`resetall
`timescale 1 ns / 10 ps
`celldefine
`suppress_faults
module l1n_y(f,l,i);
	output f;
	input l,i;
	wire vdd = 1;
	reg notifier,recover;


	// specify block
	specify
		// specify parameters
		specparam          tl_ff	= 0.0 ;
		specparam          tl_fr	= 0.0 ;
		specparam           ti_ff	= 0.0 ;
		specparam           ti_fr	= 0.0 ;
		specparam            lwh	= 0.0 ;
		specparam           ihold	= 0.0 ;
		specparam          isetup	= 0.0 ;
		specparam        Fdrive$f	= 0.0 ;
		specparam        eresof$f	= 1117;
		specparam        Rdrive$f	= 0.0 ;
		specparam        eresor$f	= 1848;
		specparam       Maxload$f	= 0.0 ;
		specparam          dcap$f	= 0.0 ;
		specparam         Load$l	= 0.025 ;
		specparam       inload$l	= 0.025 ;
		specparam          Load$i	= 0.120 ;
		specparam        inload$i	= 0.126 ;
		specparam          Trans$	= 0.0 ;
		specparam           Area$	= 1260;
		specparam          Power$	= 0.0 ;

		// path delays
		(posedge l =>   (f -: i))	= (tl_fr,tl_ff);
                if (l)
		(         i -=>          f)	= (ti_fr,ti_ff);

		// timing check
		$setuphold(negedge l, i, isetup, ihold, notifier);
		$width(posedge l, lwh, 0, notifier);
		$width(negedge l, lwh, 0, notifier);
	endspecify

	// instantiation
	`ifdef SYNTH
		reg ti;
		always @(i or l)
			if( l==1 ) ti=i;
	`else
		udp_lat (ti,l,i,vdd,vdd,notifier,recover);
	`endif

	not (f,ti);

endmodule
`nosuppress_faults
`endcelldefine
