// Last Change for CiK2.0 
// 12 Mar 93 
`resetall
`timescale 1 ns / 10 ps
`celldefine
`suppress_faults
module l2n_y(f,l0,l1,i0,i1);
	output f;
	input l0,l1,i0,i1;
	wire vdd = 1;
	reg notifier,recover;


	// specify block
	specify
		// specify parameters
		specparam          tl0_ff	= 0.0 ;
		specparam          tl1_ff	= 0.0 ;
		specparam          tl0_fr	= 0.0 ;
		specparam          tl1_fr	= 0.0 ;
		specparam           ti0_ff	= 0.0 ;
		specparam           ti1_ff	= 0.0 ;
		specparam           ti0_fr	= 0.0 ;
		specparam           ti1_fr	= 0.0 ;
		specparam            l0wh	= 0.0 ;
		specparam            l1wh	= 0.0 ;
		specparam           i0hold	= 0.0 ;
		specparam           i1hold	= 0.0 ;
		specparam          i0setup	= 0.0 ;
		specparam          i1setup	= 0.0 ;
		specparam        Fdrive$f	= 0.0 ;
		specparam        eresof$f	= 534 ;
		specparam        Rdrive$f	= 0.0 ;
		specparam        eresor$f	= 964 ;
		specparam       Maxload$f	= 0.0 ;
		specparam          dcap$f	= 0.0 ;
		specparam         Load$l0	= 0.025 ;
		specparam         Load$l1	= 0.025 ;
		specparam       inload$l0	= 0.025 ;
		specparam       inload$l1	= 0.025 ;
		specparam          Load$i0	= 0.190 ;
		specparam          Load$i1	= 0.188 ;
		specparam        inload$i0	= 0.190 ;
		specparam        inload$i1	= 0.188 ;
		specparam          Trans$	= 0.0 ;
		specparam           Area$	= 1764;
		specparam          Power$	= 0.0 ;

		// path delays
		(posedge l0 =>   (f +: i0))	= (tl0_fr,tl0_ff);
                if (l0)
		(         i0 +=>          f)	= (ti0_fr,ti0_ff);

		// timing check
		$setuphold(negedge l0, i0, i0setup, i0hold, notifier);
		$width(posedge l0, l0wh, 0, notifier);
		$width(negedge l0, l0wh, 0, notifier);
		// path delays
		(posedge l1 =>   (f +: i1))	= (tl1_fr,tl1_ff);
                if (l1)
		(         i1 +=>          f)	= (ti1_fr,ti1_ff);

		// timing check
		$setuphold(negedge l1, i1, i1setup, i1hold, notifier);
		$width(posedge l1, l1wh, 0, notifier);
		$width(negedge l1, l1wh, 0, notifier);
	endspecify

	// instantiation
	wire x1;
	wire x2;
	wire i_mux;
	wire l_or;
	and(x1,i0,l0);
	and(x2,i1,l1);
	or(i_mux,x1,x2);
	or(l_or,l0,l1);
	`ifdef SYNTH
		reg ti;
		always @(i_mux or l_or)
			if( l_or==1 ) ti=i_mux;
	`else
		udp_lat (ti,l_or,i_mux,vdd,vdd,notifier,recover);
	`endif

	not (f,ti);

endmodule
`nosuppress_faults
`endcelldefine
