// Last Change for CiK2.0 
// 12 Mar 93 
`resetall
`timescale 1 ns / 10 ps
`celldefine
`suppress_faults
module ms2sx_y(t,f,l,di,si,se,s);
	output t,f;
	input l,di,si,se,s;
	reg notifier;


	// specify block
	specify
		// specify parameters
		specparam         tl_fr		= 0.0 ;
		specparam         tl_ff		= 0.0 ;
		specparam          tl_tf	= 0.0 ;
		specparam          tl_tr	= 0.0 ;
		specparam            lwl	= 0.0 ;
		specparam            lwh	= 0.0 ;
		specparam           ihold	= 0.0 ;
		specparam          isetup	= 0.0 ;
		specparam       Fdrive$f	= 0.0 ;
		specparam       eresof$f	= 1548;
		specparam       Rdrive$f	= 0.0 ;
		specparam       eresor$f	= 964 ;
		specparam        Fdrive$t	= 0.0 ;
		specparam        eresof$t	= 1548;
		specparam        Rdrive$t	= 0.0 ;
		specparam        eresor$t	= 964 ;
		specparam       Maxload$t	= 0.0 ;
		specparam          dcap$t	= 0.0 ;
		specparam      Maxload$f	= 0.0 ;
		specparam         dcap$f	= 0.0 ;
		specparam         Load$l	= 0.088 ;
		specparam          Load$si	= 0.086 ;
		specparam         Load$di	= 0.085 ;
		specparam          Load$se	= 0.133 ;
		specparam       inload$l	= 0.088 ;
		specparam        inload$si	= 0.086 ;
		specparam       inload$di	= 0.085 ;
		specparam        inload$se	= 0.133 ;
		specparam           Trans$	= 0.0 ;
		specparam           Area$	= 5796;
		specparam          Power$	= 0.0 ;

		// path delays
		( negedge l =>  (t  +: di))	= (tl_tr,tl_tf);
		( negedge l =>  (f -: di))	= (tl_fr,tl_ff);

		// timing check
		$setuphold(negedge l, di, isetup, ihold, notifier);
		$width(posedge l, lwl, 0, notifier);
		$width(negedge l, lwh, 0, notifier);
	endspecify

	// Mux2
        wire nse,sesi,sedi,i;
	not(nse,se);
	and(sesi,se,si);
	and(sedi,nse,di);
	or(i,sesi,sedi);

	// instantiation
        `ifdef SYNTH
                reg ti;
                always @(negedge l)
                        ti = i;
        `else
                wire vdd = 1;
                wire sn;
                wire ln;
		not (sn,s);
		not (ln,l);
                udp_dff (ti,ln,i,vdd,sn,notifier);
        `endif

	buf (t,ti);
	not (f,ti);

endmodule
`nosuppress_faults
`endcelldefine
