// Last Change for CiK2.0 
// 12 Mar 93 
`resetall
`timescale 1 ns / 10 ps
`celldefine
`suppress_faults
module l1x_y(t,f,l,i);
	output t,f;
	input l,i;
	wire vdd = 1;
	reg notifier,recover;


	// specify block
	specify
		// specify parameters
		specparam         tl_ff	= 0.0 ;
		specparam         tl_fr	= 0.0 ;
		specparam          ti_ff	= 0.0 ;
		specparam          ti_fr	= 0.0 ;
		specparam          tl_tf	= 0.0 ;
		specparam          tl_tr	= 0.0 ;
		specparam           ti_tf	= 0.0 ;
		specparam           ti_tr	= 0.0 ;
		specparam            lwh	= 0.0 ;
		specparam           ihold	= 0.0 ;
		specparam          isetup	= 0.0 ;
		specparam       Fdrive$f	= 0.0 ;
		specparam       eresof$f	= 1548;
		specparam       Rdrive$f	= 0.0 ;
		specparam       eresor$f	= 964 ;
		specparam        Fdrive$t	= 0.0 ;
		specparam        eresof$t	= 1548;
		specparam        Rdrive$t	= 0.0 ;
		specparam        eresor$t	= 964 ;
		specparam       Maxload$t	= 0.0 ;
		specparam          dcap$t	= 0.0 ;
		specparam      Maxload$f	= 0.0 ;
		specparam         dcap$f	= 0.0 ;
		specparam         Load$l	= 0.025 ;
		specparam       inload$l	= 0.025 ;
		specparam          Load$i	= 0.051 ;
		specparam        inload$i	= 0.051 ;
		specparam          Trans$	= 0.0 ;
		specparam           Area$	= 2268;
		specparam          Power$	= 0.0 ;

		// path delays
		(posedge l =>   (t +: i))	= (tl_tr,tl_tf);
		(posedge l =>  (f -: i))	= (tl_fr,tl_ff);
                if (l)
		(         i +=>          t)	= (ti_tr,ti_tf);
                if (l)
		(         i -=>         f)	= (ti_fr,ti_ff);

		// timing check
		$setuphold(negedge l, i, isetup, ihold, notifier);
		$width(posedge l, lwh, 0, notifier);
		$width(negedge l, lwh, 0, notifier);
	endspecify

	// instantiation
	`ifdef SYNTH
		reg ti;
		always @(i or l)
			if( l==1 ) ti=i;
	`else
		udp_lat (ti,l,i,vdd,vdd,notifier,recover);
	`endif

	buf (t,ti);
	not (f,ti);

endmodule
`nosuppress_faults
`endcelldefine
