// Last Change for CiK2.0 
// 12 Mar 93 
`resetall
`timescale 1 ns / 10 ps
`celldefine
`suppress_faults
module l5r_y(t,l0,l1,l2,l3,l4,i0,i1,i2,i3);
	output t;
	input l0,l1,l2,l3,l4,i0,i1,i2,i3;
	wire vdd = 1;
	reg notifier,recover;


	// specify block
	specify
		// specify parameters
		specparam          tl0_tf	= 0.0 ;
		specparam          tl1_tf	= 0.0 ;
		specparam          tl2_tf	= 0.0 ;
		specparam          tl3_tf	= 0.0 ;
		specparam          tl4_tf	= 0.0 ;
		specparam          tl0_tr	= 0.0 ;
		specparam          tl1_tr	= 0.0 ;
		specparam          tl2_tr	= 0.0 ;
		specparam          tl3_tr	= 0.0 ;
		specparam          tl4_tr	= 0.0 ;
		specparam           ti0_tf	= 0.0 ;
		specparam           ti1_tf	= 0.0 ;
		specparam           ti2_tf	= 0.0 ;
		specparam           ti3_tf	= 0.0 ;
		specparam           ti0_tr	= 0.0 ;
		specparam           ti1_tr	= 0.0 ;
		specparam           ti2_tr	= 0.0 ;
		specparam           ti3_tr	= 0.0 ;
		specparam            l0wh	= 0.0 ;
		specparam            l1wh	= 0.0 ;
		specparam            l2wh	= 0.0 ;
		specparam            l3wh	= 0.0 ;
		specparam            l4wh	= 0.0 ;
		specparam           i0hold	= 0.0 ;
		specparam           i1hold	= 0.0 ;
		specparam           i2hold	= 0.0 ;
		specparam           i3hold	= 0.0 ;
		specparam          i0setup	= 0.0 ;
		specparam          i1setup	= 0.0 ;
		specparam          i2setup	= 0.0 ;
		specparam          i3setup	= 0.0 ;
		specparam        Fdrive$t	= 0.0 ;
		specparam        eresof$t	= 2048;
		specparam        Rdrive$t	= 0.0 ;
		specparam        eresor$t	= 1848;
		specparam       Maxload$t	= 0.0 ;
		specparam          dcap$t	= 0.0 ;
		specparam         Load$l0	= 0.025 ;
		specparam         Load$l1	= 0.026 ;
		specparam         Load$l2	= 0.025 ;
		specparam         Load$l3	= 0.025 ;
		specparam         Load$l4	= 0.024 ;
		specparam       inload$l0	= 0.025 ;
		specparam       inload$l1	= 0.026 ;
		specparam       inload$l2	= 0.025 ;
		specparam       inload$l3	= 0.025 ;
		specparam       inload$l4	= 0.024 ;
		specparam          Load$i0	= 0.142 ;
		specparam          Load$i1	= 0.142 ;
		specparam          Load$i2	= 0.142 ;
		specparam          Load$i3	= 0.142 ;
		specparam        inload$i0	= 0.142 ;
		specparam        inload$i1	= 0.142 ;
		specparam        inload$i2	= 0.142 ;
		specparam        inload$i3	= 0.142 ;
		specparam          Trans$	= 0.0 ;
		specparam           Area$	= 2772;
		specparam          Power$	= 0.0 ;

		// path delays
		(posedge l0 =>   (t +: i0))	= (tl0_tr,tl0_tf);
                if (l0)
		(         i0 +=>          t)	= (ti0_tr,ti0_tf);

		// timing check
		$setuphold(negedge l0, i0, i0setup, i0hold, notifier);
		$width(posedge l0, l0wh, 0, notifier);
		$width(negedge l0, l0wh, 0, notifier);
		// path delays
		(posedge l1 =>   (t +: i1))	= (tl1_tr,tl1_tf);
                if (l1)
		(         i1 +=>          t)	= (ti1_tr,ti1_tf);

		// timing check
		$setuphold(negedge l1, i1, i1setup, i1hold, notifier);
		$width(posedge l1, l1wh, 0, notifier);
		$width(negedge l1, l1wh, 0, notifier);
		// path delays
		(posedge l2 =>   (t +: i2))	= (tl2_tr,tl2_tf);
                if (l2)
		(         i2 +=>          t)	= (ti2_tr,ti2_tf);

		// timing check
		$setuphold(negedge l2, i2, i2setup, i2hold, notifier);
		$width(posedge l2, l2wh, 0, notifier);
		$width(negedge l2, l2wh, 0, notifier);
		// path delays
		(posedge l3 =>   (t +: i3))	= (tl3_tr,tl3_tf);
                if (l3)
		(         i3 +=>          t)	= (ti3_tr,ti3_tf);

		// timing check
		$setuphold(negedge l3, i3, i3setup, i3hold, notifier);
		$width(posedge l3, l3wh, 0, notifier);
		$width(negedge l3, l2wh, 0, notifier);
	endspecify

	// instantiation
	wire x1;
	wire x2;
	wire x3;
	wire x4;
	wire y1;
	wire y2;
	wire y3;
	wire y4;
	wire y5;
	wire i_mux;
	wire l_or;
	wire reset;
	and(x1,i0,l0);
	and(x2,i1,l1);
	and(x3,i2,l2);
	and(x4,i3,l3);
	or(y1,x1,x2);
	or(y2,x3,x4);
	or(i_mux,y1,y2);
	or(y3,l0,l1);
	or(y4,l2,l3);
	or(y5,y3,y4);
	or(l_or,l4,y4);
	not(reset,l4);
	`ifdef SYNTH
		reg ti;
		always @(i_mux or l_or)
			if( l_or==1 ) ti=i_mux;
	`else
		udp_lat (ti,l_or,i_mux,reset,vdd,notifier,recover);
	`endif

	buf (t,ti);

endmodule
`nosuppress_faults
`endcelldefine
