// Last Change for CiK2.0 
// 12 Mar 93 
`resetall
`timescale 1 ns / 10 ps
`celldefine
`suppress_faults
module ms2n_y(f,l,di,si,se);
	output f;
	input l,di,si,se;
	reg notifier;


	// specify block
	specify
		// specify parameters
		specparam          tl_ff	= 0.0 ;
		specparam          tl_fr	= 0.0 ;
		specparam            lwl	= 0.0 ;
		specparam            lwh	= 0.0 ;
		specparam           ihold	= 0.0 ;
		specparam          isetup	= 0.0 ;
		specparam        Fdrive$f	= 0.0 ;
		specparam        eresof$f	= 1024;
		specparam        Rdrive$f	= 0.0 ;
		specparam        eresor$f	= 964 ;
		specparam       Maxload$f	= 0.0 ;
		specparam          dcap$f	= 0.0 ;
		specparam         Load$l	= 0.088 ;
		specparam          Load$si	= 0.086 ;
		specparam         Load$di	= 0.085 ;
		specparam          Load$se	= 0.133 ;
		specparam       inload$l	= 0.088 ;
		specparam        inload$si	= 0.086 ;
		specparam       inload$di	= 0.085 ;
		specparam        inload$se	= 0.133 ;
		specparam           Trans$	= 0.0 ;
		specparam           Area$	= 4284;
		specparam          Power$	= 0.0 ;

		// path delays
		( negedge l =>  (f  +: di))	= (tl_fr,tl_ff);

		// timing check
		$setuphold(negedge l, di, isetup, ihold, notifier);
		$width(posedge l, lwl, 0, notifier);
		$width(negedge l, lwh, 0, notifier);
	endspecify

	// Mux 2
	wire nse,sesi,sedi,i;
	not(nse,se);
	and(sesi,se,si);
	and(sedi,nse,di);
	or(i,sesi,sedi);

	// instantiation
        `ifdef SYNTH
                reg ti;
                always @(negedge l)
                        ti = i;
        `else
                wire vdd = 1;
                wire ln;
		not(ln,l);
                udp_dff (ti,ln,i,vdd,vdd,notifier);
        `endif

	not (f,ti);

endmodule
`nosuppress_faults
`endcelldefine
