// Last Change for CiK2.0 
// 07 Jan 1999
`resetall
`timescale 1 ns / 10 ps
`celldefine
`suppress_faults
module ms2dp4_y(t,ck,di,si,se);
	output t;
	input ck,di,si,se;
	reg notifier;


	// specify block
	specify
		// specify parameters
		specparam          tl_tf	= 0.0 ;
		specparam          tl_tr	= 0.0 ;
		specparam            lwl	= 0.0 ;
		specparam            lwh	= 0.0 ;
		specparam           ihold	= 0.0 ;
		specparam          isetup	= 0.0 ;
		specparam        Fdrive$t	= 0.0 ;
		specparam        eresof$t	= 640;
		specparam        Rdrive$t	= 0.0 ;
		specparam        eresor$t	= 650 ;
		specparam       Maxload$t	= 0.0 ;
		specparam          dcap$t	= 0.0 ;
		specparam         Load$ck	= 0.026 ;
		specparam          Load$si	= 0.043 ;
		specparam         Load$di	= 0.042 ;
		specparam          Load$se	= 0.062 ;
		specparam       inload$ck	= 0.026 ;
		specparam        inload$si	= 0.043 ;
		specparam       inload$di	= 0.042 ;
		specparam        inload$se	= 0.062 ;
		specparam           Trans$	= 38.0 ;
		specparam           Area$	= 5796;
		specparam          Power$	= 0.0 ;

		// path delays
		( negedge ck =>  (t  +: di))	= (tl_tr,tl_tf);

		// timing check
		$setuphold(negedge ck, di, isetup, ihold, notifier);
		$width(posedge ck, lwl, 0, notifier);
		$width(negedge ck, lwh, 0, notifier);
	endspecify

	// Mux 2
	wire nse,sesi,sedi,i;
	not(nse,se);
	and(sesi,se,si);
	and(sedi,nse,di);
	or(i,sesi,sedi);

	// instantiation
        `ifdef SYNTH
                reg ti;
                always @(negedge ck)
                        ti = i;
        `else
                wire vdd = 1;
                wire ln;
		not(ln,ck);
                udp_dff (ti,ln,i,vdd,vdd,notifier);
        `endif

	buf (t,ti);

endmodule
`nosuppress_faults
`endcelldefine
