// Last Change for CiK2.0 
// 07 Jan 1999
`resetall
`timescale 1 ns / 10 ps
`celldefine
`suppress_faults
module msdp2_y(t,ck,di);
	output t;
	input ck,di;
	reg notifier;


	// specify block
	specify
		// specify parameters
		specparam          tl_tf	= 0.0 ;
		specparam          tl_tr	= 0.0 ;
		specparam            lwl	= 0.0 ;
		specparam            lwh	= 0.0 ;
		specparam           ihold	= 0.0 ;
		specparam          isetup	= 0.0 ;
		specparam        Fdrive$t	= 0.0 ;
		specparam        eresof$t	= 1270;
		specparam        Rdrive$t	= 0.0 ;
		specparam        eresor$t	= 1300 ;
		specparam       Maxload$t	= 0.0 ;
		specparam          dcap$t	= 0.0 ;
		specparam         Load$ck	= 0.026 ;
		specparam          Load$di	= 0.041 ;
		specparam       inload$ck	= 0.026 ;
		specparam        inload$di	= 0.041 ;
		specparam           Trans$	= 34.0 ;
		specparam           Area$	= 4788;
		specparam          Power$	= 0.0 ;

		// path delays
		( negedge ck =>  (t  +: di))	= (tl_tr,tl_tf);

		// timing check
		$setuphold(negedge ck, di, isetup, ihold, notifier);
		$width(posedge ck, lwl, 0, notifier);
		$width(negedge ck, lwh, 0, notifier);
	endspecify

	// instantiation
        `ifdef SYNTH
                reg ti;
                always @(negedge ck)
                ti = di;
        `else
		wire vdd = 1;
		wire ln;
		not(ln,ck);
		udp_dff (ti,ln,di,vdd,vdd,notifier);
        `endif

	buf (t,ti);

endmodule
`nosuppress_faults
`endcelldefine
